OGRE: Ogre::Frustum Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Frustum Class Reference
Core » Scene

A frustum represents a pyramid, capped at the near and far end which is used to represent either a visible area or a projection area. More...

`#include <OgreFrustum.h>`

Inheritance diagram for Ogre::Frustum:
[legend]

## Public Types
typedef Vector3 | Corners[8]
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions
| Frustum (const String &name=BLANKSTRING)
| Named constructor.
virtual | ~Frustum ()
void | _notifyCurrentCamera (Camera *cam) override
| Internal method to notify the object of the camera to be used for the next rendering operation.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
void | calcViewMatrixRelative (const Vector3 &relPos, Matrix4 &matToUpdate) const
| Calculate a view matrix for this frustum, relative to a potentially dynamic point.
void | disableCustomNearClipPlane (void)
| Disables any custom near clip plane.
void | disableReflection (void)
| Disables reflection modification previously turned on with enableReflection.
void | enableCustomNearClipPlane (const MovablePlane *plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
void | enableCustomNearClipPlane (const Plane &plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.
void | enableReflection (const MovablePlane *p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
void | enableReflection (const Plane &p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified.
Real | getAspectRatio (void) const
| Retrieves the current aspect ratio.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
const ColourValue & | getDebugColour () const
virtual float | getFarClipDistance (void) const
| Retrieves the distance from the frustum to the far clipping plane.
Real | getFocalLength () const
| Returns focal length of frustum.
const Radian & | getFOVy (void) const
| Retrieves the frustums Y-dimension Field Of View (FOV).
RealRect | getFrustumExtents () const
| Get the extents of the frustum in view space.
const Vector2 & | getFrustumOffset () const
| Retrieves the frustum offsets.
virtual const Plane & | getFrustumPlane (unsigned short plane) const
| Retrieves a specified plane of the frustum (world space).
virtual const Plane * | getFrustumPlanes (void) const
| Retrieves the clipping planes of the frustum (world space).
const String & | getMovableType (void) const override
| Returns the type name of this object.
virtual float | getNearClipDistance (void) const
| Retrieves the distance from the frustum to the near clipping plane.
virtual const Quaternion & | getOrientationForViewUpdate (void) const
| Get the derived orientation of this frustum.
Real | getOrthoWindowHeight () const
| Gets the orthographic window height, for use with orthographic rendering only.
Real | getOrthoWindowWidth () const
| Gets the orthographic window width, for use with orthographic rendering only.
PlaneBoundedVolume | getPlaneBoundedVolume ()
| Gets a world-space list of planes enclosing the frustum.
virtual const Vector3 & | getPositionForViewUpdate (void) const
| Get the derived position of this frustum.
const Matrix4 & | getProjectionMatrix (void) const
| Gets the normal projection matrix for this frustum.
const Matrix4 & | getProjectionMatrixWithRSDepth (void) const
| Gets the depth-adjusted projection matrix for the current rendersystem.
ProjectionType | getProjectionType (void) const
| Retrieves info on the type of projection used (orthographic or perspective).
const Affine3 & | getReflectionMatrix (void) const
| Returns the reflection matrix of the frustum if appropriate.
const Plane & | getReflectionPlane (void) const
| Returns the reflection plane of the frustum if appropriate.
uint32 | getTypeFlags (void) const override
| Get the 'type flags' for this MovableObject.
virtual const Affine3 & | getViewMatrix (void) const
| Gets the view matrix for this frustum.
virtual const Corners & | getWorldSpaceCorners (void) const
| Gets the world space corners of the frustum.
bool | isCustomNearClipPlaneEnabled (void) const
| Is a custom near clip plane in use?
bool | isCustomProjectionMatrixEnabled (void) const
| Returns whether a custom projection matrix is in use.
bool | isCustomViewMatrixEnabled (void) const
| Returns whether a custom view matrix is in use.
bool | isReflected (void) const
| Returns whether this frustum is being reflected.
virtual bool | isVisible (const AxisAlignedBox &bound, FrustumPlane *culledBy=0) const
| Tests whether the given container is visible in the Frustum.
virtual bool | isVisible (const Sphere &bound, FrustumPlane *culledBy=0) const
| Tests whether the given container is visible in the Frustum.
virtual bool | isVisible (const Vector3 &vert, FrustumPlane *culledBy=0) const
| Tests whether the given vertex is visible in the Frustum.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual bool | projectSphere (const Sphere &sphere, Real *left, Real *top, Real *right, Real *bottom) const
| Project a sphere onto the near plane and get the bounding rectangle.
void | resetFrustumExtents ()
| Reset the frustum extents to be automatically derived from other params.
void | setAspectRatio (Real ratio)
| Sets the aspect ratio for the frustum viewport.
void | setCustomProjectionMatrix (bool enable, const Matrix4 &projectionMatrix=Matrix4::IDENTITY)
| Set whether to use a custom projection matrix on this frustum.
void | setCustomViewMatrix (bool enable, const Affine3 &viewMatrix=Affine3::IDENTITY)
| Set whether to use a custom view matrix on this frustum.
void | setDebugColour (const ColourValue &col)
void | setFarClipDistance (float farDist)
| Sets the distance to the far clipping plane.
void | setFocalLength (Real focalLength=1.0)
| Sets frustum focal length (used in stereo rendering).
void | setFOVy (const Radian &fovy)
| Sets the Y-dimension Field Of View (FOV) of the frustum.
void | setFrustumExtents (Real left, Real right, Real top, Real bottom)
| Manually set the extents of the frustum.
void | setFrustumOffset (const Vector2 &offset)
| Sets frustum offsets, used in stereo rendering.
void | setFrustumOffset (Real horizontal=0.0, Real vertical=0.0)
| Sets frustum offsets, used in stereo rendering.
void | setNearClipDistance (float nearDist)
| Sets the position of the near clipping plane.
void | setOrthoWindow (Real w, Real h)
| Sets the orthographic window settings, for use with orthographic rendering only.
void | setOrthoWindowHeight (Real h)
| Sets the orthographic window height, for use with orthographic rendering only.
void | setOrthoWindowWidth (Real w)
| Sets the orthographic window width, for use with orthographic rendering only.
virtual void | setProjectionType (ProjectionType pt)
| Sets the type of projection to use (orthographic or perspective).
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Static Public Attributes
static const Real | INFINITE_FAR_PLANE_ADJUST
| Small constant used to reduce far plane projection to avoid inaccuracies.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

A frustum represents a pyramid, capped at the near and far end which is used to represent either a visible area or a projection area.

Can be used for a number of applications.

## Member Typedef Documentation

## ◆ Corners

typedef Vector3 Ogre::Frustum::Corners[8]

## Constructor & Destructor Documentation

## ◆ Frustum()

Ogre::Frustum::Frustum | ( | const String & | name = BLANKSTRING | ) |

Named constructor.

References Ogre::BLANKSTRING.

Referenced by Ogre::Camera::getCullingFrustum(), and Ogre::Camera::setCullingFrustum().

## ◆ ~Frustum()

virtual Ogre::Frustum::~Frustum | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ setFOVy()

void Ogre::Frustum::setFOVy | ( | const Radian & | fovy | ) |

Sets the Y-dimension Field Of View (FOV) of the frustum.

Field Of View (FOV) is the angle made between the frustum's position, and the edges of the 'screen' onto which the scene is projected. High values (90+ degrees) result in a wide-angle, fish-eye kind of view, low values (30- degrees) in a stretched, telescopic kind of view. Typical values are between 45 and 60 degrees.

  This value represents the VERTICAL field-of-view. The horizontal field of view is calculated from this depending on the dimensions of the viewport (they will only be the same if the viewport is square).

## ◆ getFOVy()

const Radian & Ogre::Frustum::getFOVy | ( | void |  | ) | const

Retrieves the frustums Y-dimension Field Of View (FOV).

## ◆ setNearClipDistance()

void Ogre::Frustum::setNearClipDistance | ( | float | nearDist | ) |

Sets the position of the near clipping plane.

The position of the near clipping plane is the distance from the frustums position to the screen on which the world is projected. The near plane distance, combined with the field-of-view and the aspect ratio, determines the size of the viewport through which the world is viewed (in world coordinates). Note that this world viewport is different to a screen viewport, which has it's dimensions expressed in pixels. The frustums viewport should have the same aspect ratio as the screen viewport it renders into to avoid distortion.

Parameters

  nearDist | The distance to the near clipping plane from the frustum in world coordinates.

## ◆ getNearClipDistance()

virtual float Ogre::Frustum::getNearClipDistance | ( | void |  | ) | const
| inlinevirtual

Retrieves the distance from the frustum to the near clipping plane.

Reimplemented in Ogre::Camera.

## ◆ setFarClipDistance()

void Ogre::Frustum::setFarClipDistance | ( | float | farDist | ) |

Sets the distance to the far clipping plane.

The view frustum is a pyramid created from the frustum position and the edges of the viewport. This method sets the distance for the far end of that pyramid. Different applications need different values: e.g. a flight sim needs a much further far clipping plane than a first-person shooter. An important point here is that the larger the ratio between near and far clipping planes, the lower the accuracy of the Z-buffer used to depth-cue pixels. This is because the Z-range is limited to the size of the Z buffer (16 or 32-bit) and the max values must be spread over the gap between near and far clip planes. As it happens, you can affect the accuracy far more by altering the near distance rather than the far distance, but keep this in mind.

Parameters

  farDist | The distance to the far clipping plane from the frustum in world coordinates.If you specify 0, this means an infinite view distance which is useful especially when projecting shadows; but be careful not to use a near distance too close.

## ◆ getFarClipDistance()

virtual float Ogre::Frustum::getFarClipDistance | ( | void |  | ) | const
| inlinevirtual

Retrieves the distance from the frustum to the far clipping plane.

Reimplemented in Ogre::Camera.

## ◆ setAspectRatio()

void Ogre::Frustum::setAspectRatio | ( | Real | ratio | ) |

Sets the aspect ratio for the frustum viewport.

The ratio between the x and y dimensions of the rectangular area visible through the frustum is known as aspect ratio: aspect = width / height .

  The default for most fullscreen windows is 1.3333 - this is also assumed by Ogre unless you use this method to state otherwise.

## ◆ getAspectRatio()

Real Ogre::Frustum::getAspectRatio | ( | void |  | ) | const

Retrieves the current aspect ratio.

## ◆ setFrustumOffset() [1/2]

void Ogre::Frustum::setFrustumOffset | ( | const Vector2 & | offset | ) |

Sets frustum offsets, used in stereo rendering.

You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets.

  The frustum offsets is in world coordinates, and default to (0, 0) - no offsets.

Parameters

  offset | The horizontal and vertical plane offsets.

## ◆ setFrustumOffset() [2/2]

void Ogre::Frustum::setFrustumOffset | ( | Real | horizontal = 0.0,
|  | Real | vertical = 0.0 )

Sets frustum offsets, used in stereo rendering.

You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets.

  The frustum offsets is in world coordinates, and default to (0, 0) - no offsets.

Parameters

  horizontal | The horizontal plane offset.
  vertical | The vertical plane offset.

## ◆ getFrustumOffset()

const Vector2 & Ogre::Frustum::getFrustumOffset | ( |  | ) | const

Retrieves the frustum offsets.

## ◆ setFocalLength()

void Ogre::Frustum::setFocalLength | ( | Real | focalLength = 1.0 | ) |

Sets frustum focal length (used in stereo rendering).

Parameters

  focalLength | The distance to the focal plane from the frustum in world coordinates.

## ◆ getFocalLength()

Real Ogre::Frustum::getFocalLength | ( |  | ) | const

Returns focal length of frustum.

## ◆ setFrustumExtents()

void Ogre::Frustum::setFrustumExtents | ( | Real | left,
|  | Real | right,
|  | Real | top,
|  | Real | bottom )

Manually set the extents of the frustum.

Parameters

  left,right,top,bottom | The position where the side clip planes intersect the near clip plane, in eye space

## ◆ resetFrustumExtents()

void Ogre::Frustum::resetFrustumExtents | ( |  | ) |

Reset the frustum extents to be automatically derived from other params.

## ◆ getFrustumExtents()

RealRect Ogre::Frustum::getFrustumExtents | ( |  | ) | const

Get the extents of the frustum in view space.

## ◆ getProjectionMatrixWithRSDepth()

const Matrix4 & Ogre::Frustum::getProjectionMatrixWithRSDepth | ( | void |  | ) | const

Gets the depth-adjusted projection matrix for the current rendersystem.

This differs from the rendering-API independent getProjectionMatrix in that it the resulting depth range may vary between render systems since D3D uses [0,1] and GL uses [-1,1]. This is required for vertex and fragment programs.

## ◆ getProjectionMatrix()

const Matrix4 & Ogre::Frustum::getProjectionMatrix | ( | void |  | ) | const

Gets the normal projection matrix for this frustum.

i.e. the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1]. This is required for some uniform algebra.

## ◆ getViewMatrix()

virtual const Affine3 & Ogre::Frustum::getViewMatrix | ( | void |  | ) | const
| virtual

Gets the view matrix for this frustum.

Mainly for use by OGRE internally.

Reimplemented in Ogre::Camera.

## ◆ calcViewMatrixRelative()

void Ogre::Frustum::calcViewMatrixRelative | ( | const Vector3 & | relPos,
|  | Matrix4 & | matToUpdate ) const

Calculate a view matrix for this frustum, relative to a potentially dynamic point.

Mainly for use by OGRE internally when using camera-relative rendering for frustums that are not the centre (e.g. texture projection)

## ◆ setCustomViewMatrix()

void Ogre::Frustum::setCustomViewMatrix | ( | bool | enable,
|  | const Affine3 & | viewMatrix = Affine3::IDENTITY )

Set whether to use a custom view matrix on this frustum.

This is an advanced method which allows you to manually set the view matrix on this frustum, rather than having it calculate itself based on it's position and orientation.

Note
  After enabling a custom view matrix, the frustum will no longer update on its own based on position / orientation changes. You are completely responsible for keeping the view matrix up to date. The custom matrix will be returned from getViewMatrix.

Parameters

  enable | If `true`, the custom view matrix passed as the second parameter will be used in preference to an auto calculated one. If false, the frustum will revert to auto calculating the view matrix.
  viewMatrix | The custom view matrix to use

See also
  Frustum::setCustomProjectionMatrix

References Ogre::Affine3::IDENTITY.

## ◆ isCustomViewMatrixEnabled()

bool Ogre::Frustum::isCustomViewMatrixEnabled | ( | void |  | ) | const
| inline

Returns whether a custom view matrix is in use.

## ◆ setCustomProjectionMatrix()

void Ogre::Frustum::setCustomProjectionMatrix | ( | bool | enable,
|  | const Matrix4 & | projectionMatrix = Matrix4::IDENTITY )

Set whether to use a custom projection matrix on this frustum.

This is an advanced method which allows you to manually set the projection matrix on this frustum, rather than having it calculate itself based on it's position and orientation.

Note
  After enabling a custom projection matrix, the frustum will no longer update on its own based on field of view and near / far distance changes. You are completely responsible for keeping the projection matrix up to date if those values change. The custom matrix will be returned from getProjectionMatrix and derivative functions.

Parameters

  enable | If `true`, the custom projection matrix passed as the second parameter will be used in preference to an auto calculated one. If `false`, the frustum will revert to auto calculating the projection matrix.
  projectionMatrix | The custom view matrix to use.

See also
  Frustum::setCustomViewMatrix

References Ogre::Matrix4::IDENTITY.

## ◆ isCustomProjectionMatrixEnabled()

bool Ogre::Frustum::isCustomProjectionMatrixEnabled | ( | void |  | ) | const
| inline

Returns whether a custom projection matrix is in use.

## ◆ getFrustumPlanes()

virtual const Plane * Ogre::Frustum::getFrustumPlanes | ( | void |  | ) | const
| virtual

Retrieves the clipping planes of the frustum (world space).

The clipping planes are ordered as declared in enumerate constants FrustumPlane.

## ◆ getFrustumPlane()

virtual const Plane & Ogre::Frustum::getFrustumPlane | ( | unsigned short | plane | ) | const
| virtual

Retrieves a specified plane of the frustum (world space).

Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes.

Reimplemented in Ogre::Camera.

References Ogre::MovableObject::isVisible().

## ◆ isVisible() [1/4]

virtual bool Ogre::Frustum::isVisible | ( | const AxisAlignedBox & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| virtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding box to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the box was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented in Ogre::Camera, and Ogre::PCZCamera.

## ◆ isVisible() [2/4]

virtual bool Ogre::Frustum::isVisible | ( | const Sphere & | bound,
|  | FrustumPlane * | culledBy = 0 ) const
| virtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding sphere to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented in Ogre::Camera.

## ◆ isVisible() [3/4]

virtual bool Ogre::Frustum::isVisible | ( | const Vector3 & | vert,
|  | FrustumPlane * | culledBy = 0 ) const
| virtual

Tests whether the given vertex is visible in the Frustum.

Parameters

  vert | Vertex to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented in Ogre::Camera.

## ◆ getTypeFlags()

uint32 Ogre::Frustum::getTypeFlags | ( | void |  | ) | const
| overridevirtual

Get the 'type flags' for this MovableObject.

A type flag identifies the type of the MovableObject as a bitpattern. This is used for categorical inclusion / exclusion in SceneQuery objects. By default, this method returns all ones for objects not created by a MovableObjectFactory (hence always including them); otherwise it returns the value assigned to the MovableObjectFactory. Custom objects which don't use MovableObjectFactory will need to override this if they want to be included in queries.

Reimplemented from Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::Frustum::getBoundingBox | ( | void |  | ) | const
| overridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

Reimplemented in Ogre::PCZCamera.

## ◆ getBoundingRadius()

Real Ogre::Frustum::getBoundingRadius | ( | void |  | ) | const
| overridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::Frustum::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ getMovableType()

const String & Ogre::Frustum::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ _notifyCurrentCamera()

void Ogre::Frustum::_notifyCurrentCamera | ( | Camera * | cam | ) |
| overridevirtual

Internal method to notify the object of the camera to be used for the next rendering operation.

Certain objects may want to do specific processing based on the camera position. This method notifies them in case they wish to do this.

Reimplemented from Ogre::MovableObject.

## ◆ setDebugColour()

void Ogre::Frustum::setDebugColour | ( | const ColourValue & | col | ) |
| inline

## ◆ getDebugColour()

const ColourValue & Ogre::Frustum::getDebugColour | ( |  | ) | const
| inline

## ◆ getWorldSpaceCorners()

virtual const Corners & Ogre::Frustum::getWorldSpaceCorners | ( | void |  | ) | const
| virtual

Gets the world space corners of the frustum.

The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far.

Reimplemented in Ogre::Camera.

## ◆ setProjectionType()

virtual void Ogre::Frustum::setProjectionType | ( | ProjectionType | pt | ) |
| virtual

Sets the type of projection to use (orthographic or perspective).

Default is perspective.

Reimplemented in Ogre::PCZCamera.

## ◆ getProjectionType()

ProjectionType Ogre::Frustum::getProjectionType | ( | void |  | ) | const

Retrieves info on the type of projection used (orthographic or perspective).

## ◆ setOrthoWindow()

void Ogre::Frustum::setOrthoWindow | ( | Real | w,
|  | Real | h )

Sets the orthographic window settings, for use with orthographic rendering only.

Note
  Calling this method will recalculate the aspect ratio, use setOrthoWindowHeight or setOrthoWindowWidth alone if you wish to preserve the aspect ratio but just fit one or other dimension to a particular size.

Parameters

  w | The width of the view window in world units.
  h | The height of the view window in world units.

## ◆ setOrthoWindowHeight()

void Ogre::Frustum::setOrthoWindowHeight | ( | Real | h | ) |

Sets the orthographic window height, for use with orthographic rendering only.

Note
  The width of the window will be calculated from the aspect ratio.

Parameters

  h | The height of the view window in world units.

## ◆ setOrthoWindowWidth()

void Ogre::Frustum::setOrthoWindowWidth | ( | Real | w | ) |

Sets the orthographic window width, for use with orthographic rendering only.

Note
  The height of the window will be calculated from the aspect ratio.

Parameters

  w | The width of the view window in world units.

## ◆ getOrthoWindowHeight()

Real Ogre::Frustum::getOrthoWindowHeight | ( |  | ) | const

Gets the orthographic window height, for use with orthographic rendering only.

## ◆ getOrthoWindowWidth()

Real Ogre::Frustum::getOrthoWindowWidth | ( |  | ) | const

Gets the orthographic window width, for use with orthographic rendering only.

Note
  This is calculated from the orthographic height and the aspect ratio

## ◆ enableReflection() [1/2]

void Ogre::Frustum::enableReflection | ( | const Plane & | p | ) |

Modifies this frustum so it always renders from the reflection of itself through the plane specified.

This is obviously useful for performing planar reflections.

## ◆ enableReflection() [2/2]

void Ogre::Frustum::enableReflection | ( | const MovablePlane * | p | ) |

Modifies this frustum so it always renders from the reflection of itself through the plane specified.

Note that this version of the method links to a plane so that changes to it are picked up automatically. It is important that this plane continues to exist whilst this object does; do not destroy the plane before the frustum.

This is obviously useful for performing planar reflections.

## ◆ disableReflection()

void Ogre::Frustum::disableReflection | ( | void |  | ) |

Disables reflection modification previously turned on with enableReflection.

## ◆ isReflected()

bool Ogre::Frustum::isReflected | ( | void |  | ) | const
| inline

Returns whether this frustum is being reflected.

## ◆ getReflectionMatrix()

const Affine3 & Ogre::Frustum::getReflectionMatrix | ( | void |  | ) | const
| inline

Returns the reflection matrix of the frustum if appropriate.

## ◆ getReflectionPlane()

const Plane & Ogre::Frustum::getReflectionPlane | ( | void |  | ) | const
| inline

Returns the reflection plane of the frustum if appropriate.

## ◆ projectSphere()

virtual bool Ogre::Frustum::projectSphere | ( | const Sphere & | sphere,
|  | Real * | left,
|  | Real * | top,
|  | Real * | right,
|  | Real * | bottom ) const
| virtual

Project a sphere onto the near plane and get the bounding rectangle.

Parameters

  sphere | The world-space sphere to project.
  left | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  top | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  right | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).

Returns
  `true` if the sphere was projected to a subset of the near plane, `false` if the entire near plane was contained.

Reimplemented in Ogre::Camera.

## ◆ enableCustomNearClipPlane() [1/2]

void Ogre::Frustum::enableCustomNearClipPlane | ( | const MovablePlane * | plane | ) |

Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.

There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue.

  This version of the method links to a plane, rather than requiring a by-value plane definition, and therefore you can make changes to the plane (e.g. by moving / rotating the node it is attached to) and they will automatically affect this object.

Note
  This technique only works for perspective projection.

Parameters

  plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

## ◆ enableCustomNearClipPlane() [2/2]

void Ogre::Frustum::enableCustomNearClipPlane | ( | const Plane & | plane | ) |

Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.

There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to
a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue.

Note
  This technique only works for perspective projection.

Parameters

  plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

## ◆ disableCustomNearClipPlane()

void Ogre::Frustum::disableCustomNearClipPlane | ( | void |  | ) |

Disables any custom near clip plane.

## ◆ isCustomNearClipPlaneEnabled()

bool Ogre::Frustum::isCustomNearClipPlaneEnabled | ( | void |  | ) | const
| inline

Is a custom near clip plane in use?

## ◆ visitRenderables()

void Ogre::Frustum::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## ◆ getPositionForViewUpdate()

virtual const Vector3 & Ogre::Frustum::getPositionForViewUpdate | ( | void |  | ) | const
| virtual

Get the derived position of this frustum.

Reimplemented in Ogre::Camera.

## ◆ getOrientationForViewUpdate()

virtual const Quaternion & Ogre::Frustum::getOrientationForViewUpdate | ( | void |  | ) | const
| virtual

Get the derived orientation of this frustum.

Reimplemented in Ogre::Camera.

## ◆ getPlaneBoundedVolume()

PlaneBoundedVolume Ogre::Frustum::getPlaneBoundedVolume | ( |  | ) |

Gets a world-space list of planes enclosing the frustum.

## ◆ isVisible() [4/4]

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| virtual

Returns whether or not this object is supposed to be visible or not.

Takes into account both upper rendering distance and visible flag.

Reimplemented from Ogre::MovableObject.

## Member Data Documentation

## ◆ INFINITE_FAR_PLANE_ADJUST

const Real Ogre::Frustum::INFINITE_FAR_PLANE_ADJUST
| static

Small constant used to reduce far plane projection to avoid inaccuracies.

The documentation for this class was generated from the following file:

- OgreFrustum.h